Public Class DotPainter
    Inherits Control
    Private m_BMP As Bitmap
    WriteOnly Property BMP() As Bitmap
        Set(ByVal value As Bitmap)
            m_BMP = value
            Invalidate()
        End Set
    End Property
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        If m_BMP Is Nothing Then
            e.Graphics.Clear(SystemColors.Control)
        Else
            Dim BMPWidth As Integer = m_BMP.Width
            Dim BMPHeight As Integer = m_BMP.Height
            Dim AcLeft, AcTop As Integer
            AcLeft = 0
            AcTop = 0
            Dim g As Graphics = e.Graphics
            While AcLeft < Me.Width
                AcTop = 0
                While AcTop < Me.Height
                    g.DrawImage(m_BMP, New Rectangle(AcLeft, AcTop, BMPWidth, BMPHeight))

                    AcTop += m_BMP.Height
                End While
                AcLeft += m_BMP.Width
            End While
        End If
    End Sub

    Public Sub New()
        Me.SetStyle(ControlStyles.DoubleBuffer _
     Or ControlStyles.UserPaint _
     Or ControlStyles.AllPaintingInWmPaint Or ControlStyles.ResizeRedraw, _
     True)

    End Sub
End Class
