Imports System.Xml
Public Class PicElement
    Private m_Style As RaisedStyles = RaisedStyles.None
    Private m_luConnector As Boolean = False
    Private m_ldConnector As Boolean = False
    Private m_ruConnector As Boolean = False
    Private m_rdConnector As Boolean = False
    Private m_LineIndex As Integer
    Private m_ColumnIndex As Integer

    Private m_Collection As PicElementCollection

    Public Sub New(ByVal LineIndex As Integer, ByVal ColumnIndex As Integer, ByVal Collection As PicElementCollection)
        m_LineIndex = LineIndex
        m_ColumnIndex = ColumnIndex
        m_Collection = Collection
    End Sub
    Public Sub New(ByVal LineIndex As Integer, ByVal ColumnIndex As Integer, ByVal Nd As XmlNode, ByVal Collection As PicElementCollection)
        m_LineIndex = LineIndex
        m_ColumnIndex = ColumnIndex
        m_Collection = Collection


        m_Style = CType(CInt(Nd.Attributes("Style").Value), RaisedStyles)
        m_luConnector = CBool(Nd.Attributes("luConnector").Value)
        m_ldConnector = CBool(Nd.Attributes("ldConnector").Value)
        m_ruConnector = CBool(Nd.Attributes("ruConnector").Value)
        m_rdConnector = CBool(Nd.Attributes("rdConnector").Value)
      
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Style", (CInt(m_Style)).ToString)
        Writer.WriteAttributeString("luConnector", m_luConnector.ToString)
        Writer.WriteAttributeString("ldConnector", m_ldConnector.ToString)
        Writer.WriteAttributeString("ruConnector", m_ruConnector.ToString)
        Writer.WriteAttributeString("rdConnector", m_rdConnector.ToString)
    End Sub
    ReadOnly Property LineIndex() As Integer
        Get
            Return m_LineIndex
        End Get
    End Property
    ReadOnly Property ColumnIndex() As Integer
        Get
            Return m_ColumnIndex
        End Get
    End Property
    ReadOnly Property Style() As RaisedStyles
        Get
            Return m_Style
        End Get
    End Property
    Public Sub MakeStyle()
        Dim Known As New List(Of RaisedStyles)
        Dim El As PicElement
        El = m_Collection.GetElement(Me, Positions.Top)
        If Not Known.Contains(El.Style) Then
            Known.Add(El.Style)
        End If
        El = m_Collection.GetElement(Me, Positions.Bottom)
        If Not Known.Contains(El.Style) Then
            Known.Add(El.Style)
        End If
        El = m_Collection.GetElement(Me, Positions.Left)
        If Not Known.Contains(El.Style) Then
            Known.Add(El.Style)
        End If
        El = m_Collection.GetElement(Me, Positions.Right)
        If Not Known.Contains(El.Style) Then
            Known.Add(El.Style)
        End If

        Dim Vorschlaege As New List(Of RaisedStyles)

        Vorschlaege.Add(RaisedStyles.None)
        Vorschlaege.Add(RaisedStyles.Raised)
        Vorschlaege.Add(RaisedStyles.Sunken)
        'If Known.Count <> 3 Then
        '    For Each Vorschl As RaisedStyles In Known
        '        Vorschlaege.Remove(Vorschl)
        '    Next
        'End If

        m_Style = GetStyle(Vorschlaege)

    End Sub
    Private Function GetStyle(ByVal StyleVorschlaege As List(Of RaisedStyles))
        Randomize()
        Dim Idx As Integer = CInt(Int((StyleVorschlaege.Count) * Rnd()))
        Return StyleVorschlaege(Idx)
    End Function

    Property LUConnector() As Boolean
        Get
            Return m_luConnector
        End Get
        Set(ByVal value As Boolean)
            m_luConnector = value
        End Set
    End Property
    Property LDConnector() As Boolean
        Get
            Return m_ldConnector
        End Get
        Set(ByVal value As Boolean)
            m_ldConnector = value
        End Set
    End Property
    Property RDConnector() As Boolean
        Get
            Return m_rdConnector
        End Get
        Set(ByVal value As Boolean)
            m_rdConnector = value
        End Set
    End Property
    Property RUConnector() As Boolean
        Get
            Return m_ruConnector
        End Get
        Set(ByVal value As Boolean)
            m_ruConnector = value
        End Set
    End Property
End Class
