Imports System.Drawing
Imports System.Xml
Public Class PicElementCollection
    Private m_Lines As Integer
    Private m_Columns As Integer
    Private m_Elements(,) As PicElement
    Private m_AllElements As New List(Of PicElement)
    Private m_DrawingElements As PicElementGroupCollection

    Public Sub New(ByVal nd As XmlNode)
        m_Lines = CInt(nd.Attributes("Lines").Value)
        m_Columns = CInt(nd.Attributes("Columns").Value)
        ReDim m_Elements(m_Columns - 1, m_Lines - 1)

        Dim Zhl As Integer = 0
        Dim TmpNode As XmlNode = Nothing
        For I As Integer = 0 To m_Columns - 1
            For J As Integer = 0 To m_Lines - 1
                Zhl += 1
                For Each xnd As XmlNode In nd.ChildNodes
                    If xnd.Name = "El" & Zhl.ToString Then
                        TmpNode = xnd
                        Exit For
                    End If
                Next
                m_Elements(I, J) = New PicElement(J, I, TmpNode, Me)
                m_AllElements.Add(m_Elements(I, J))
            Next
        Next
        For Each xnd As XmlNode In nd.ChildNodes
            If xnd.Name = "PicElementGroupCollection" Then
                m_DrawingElements = New PicElementGroupCollection(xnd, m_AllElements)
            End If
        Next

    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Lines", m_Lines.ToString)
        Writer.WriteAttributeString("Columns", m_Columns.ToString)
        Dim Zhl As Integer = 0
        For I As Integer = 0 To m_Columns - 1
            For J As Integer = 0 To m_Lines - 1
                Zhl += 1
                Writer.WriteStartElement("El" & Zhl.ToString)
                m_Elements(I, J).Write_XML(Writer)
                Writer.WriteEndElement()
            Next
        Next
        Writer.WriteStartElement("PicElementGroupCollection")
        m_DrawingElements.Write_XML(Writer, m_AllElements)
        Writer.WriteEndElement()

    End Sub

    Public Sub New(ByVal Lines As Integer, ByVal Columns As Integer, ByVal BaseColor As Color)

        m_Lines = Lines
        m_Columns = Columns
        ReDim m_Elements(m_Columns - 1, m_Lines - 1)
        For I As Integer = 0 To m_Columns - 1
            For J As Integer = 0 To m_Lines - 1
                m_Elements(I, J) = New PicElement(J, I, Me)
                m_AllElements.Add(m_Elements(I, J))
            Next
        Next

        'unterschiedliche Stile verteilen
        For Each El As PicElement In m_AllElements
            El.MakeStyle()
        Next
        For Each El As PicElement In m_AllElements
            MakeTopLeftConnection(El)
            MakeTopRightConnection(El)
        Next
        For Each El As PicElement In m_AllElements
            LinksTopKreuzungAusschliessen(El)
        Next
        For Each El As PicElement In m_AllElements
            BottomAngleichen(El)
        Next

        m_DrawingElements = New PicElementGroupCollection
        Dim ElementsForWork As New List(Of PicElement)
        For Each El As PicElement In m_AllElements
            If El.Style <> RaisedStyles.None Then
                ElementsForWork.Add(El)
            End If
        Next

        Dim WorkEl As PicElement
        Dim AcGroup As PicElementGroup
        While ElementsForWork.Count > 0
            WorkEl = ElementsForWork(0)
            AcGroup = New PicElementGroup

            AddChild(WorkEl, ElementsForWork, AcGroup)

            If WorkEl.Style = RaisedStyles.Raised Then
                m_DrawingElements.RaisedElements.Add(AcGroup)
            Else
                m_DrawingElements.SunkenElements.Add(AcGroup)
            End If
        End While

        If BaseColor = Color.Transparent Then
            For Each grp As PicElementGroup In m_DrawingElements.RaisedElements
                grp.Color = ColorFunctions.Zufallsfarbe
            Next
            For Each grp As PicElementGroup In m_DrawingElements.SunkenElements
                grp.Color = ColorFunctions.Zufallsfarbe
            Next
        Else
            Dim DarkColor As Color = ControlPaint.Dark(BaseColor)
            Dim LightColor As Color = ControlPaint.Light(BaseColor)
            For Each grp As PicElementGroup In m_DrawingElements.RaisedElements
                grp.Color = DarkColor
            Next
            For Each grp As PicElementGroup In m_DrawingElements.SunkenElements
                grp.Color = LightColor
            Next
        End If

    End Sub
    Public Sub FarbenNeu_Verteilen(ByVal BaseColor As Color)
        If BaseColor = Color.Transparent Then
            For Each grp As PicElementGroup In m_DrawingElements.RaisedElements
                grp.Color = ColorFunctions.Zufallsfarbe
            Next
            For Each grp As PicElementGroup In m_DrawingElements.SunkenElements
                grp.Color = ColorFunctions.Zufallsfarbe
            Next
        Else
            Dim DarkColor As Color = ControlPaint.Dark(BaseColor)
            Dim LightColor As Color = ControlPaint.Light(BaseColor)
            For Each grp As PicElementGroup In m_DrawingElements.RaisedElements
                grp.Color = DarkColor
            Next
            For Each grp As PicElementGroup In m_DrawingElements.SunkenElements
                grp.Color = LightColor
            Next
        End If
    End Sub

    Public Function DrawingElements() As PicElementGroupCollection
        Return m_DrawingElements
    End Function
    Private Sub AddChild(ByVal El As PicElement, ByVal Source As List(Of PicElement), ByVal Ziel As PicElementGroup)
        Ziel.Add(El)
        Source.Remove(El)

        If El.LUConnector Then
            Dim XEl As PicElement = GetElement(El, Positions.Left Or Positions.Top)
            If Source.Contains(XEl) Then
                AddChild(XEl, Source, Ziel)
            End If
        End If
        If El.LDConnector Then
            Dim XEl As PicElement = GetElement(El, Positions.Left Or Positions.Bottom)
            If Source.Contains(XEl) Then
                AddChild(XEl, Source, Ziel)
            End If
        End If
        If El.RUConnector Then
            Dim XEl As PicElement = GetElement(El, Positions.Right Or Positions.Top)
            If Source.Contains(XEl) Then
                AddChild(XEl, Source, Ziel)
            End If
        End If
        If El.RDConnector Then
            Dim XEl As PicElement = GetElement(El, Positions.Right Or Positions.Bottom)
            If Source.Contains(XEl) Then
                AddChild(XEl, Source, Ziel)
            End If
        End If
    End Sub
    Private Sub BottomAngleichen(ByVal El As PicElement)
        If El.LUConnector Then
            Dim LUEl As PicElement = GetElement(El, Positions.Left Or Positions.Top)
            LUEl.RDConnector = True
        End If
        If El.RUConnector Then
            Dim RUEl As PicElement = GetElement(El, Positions.Right Or Positions.Top)
            RUEl.LDConnector = True
        End If
    End Sub
    Private Sub LinksTopKreuzungAusschliessen(ByVal El As PicElement)
        If Not El.LUConnector Then Exit Sub
        Dim LeftEl As PicElement = GetElement(El, Positions.Left)
        If Not LeftEl.RUConnector Then Exit Sub

        Randomize()
        'bei linkem und aktuellen Element ist ein "berkreuzender" Conntector vorhanden
        Dim randomvalue As Integer = CInt(Int((2) * Rnd()))
        If randomvalue = 0 Then
            'linke Kreuzung entfernen
            LeftEl.RUConnector = False
        Else
            'rechte Kreuzung entfernen
            El.LUConnector = False
        End If


    End Sub
    Private Sub MakeTopLeftConnection(ByVal El As PicElement)
        Dim ConnEl As PicElement = GetElement(El, Positions.Left Or Positions.Top)
        If ConnEl.Style <> El.Style Then Exit Sub

        Randomize()
        'Wahrscheinlichkeit fr Connection soll 3:1 sein
        Dim randomvalue As Integer = CInt(Int((3 + 1) * Rnd()))
        If randomvalue = 0 Then Exit Sub

        'in allen anderen Fllen wird eine Connection erstellt
        El.LUConnector = True
    End Sub
    Private Sub MakeTopRightConnection(ByVal El As PicElement)
        Dim ConnEl As PicElement = GetElement(El, Positions.Right Or Positions.Top)
        If ConnEl.Style <> El.Style Then Exit Sub

        Randomize()
        'Wahrscheinlichkeit fr Connection soll 3:1 sein
        Dim randomvalue As Integer = CInt(Int((3 + 1) * Rnd()))
        If randomvalue = 0 Then Exit Sub

        'in allen anderen Fllen wird eine Connection erstellt
        El.RUConnector = True
    End Sub
    Public Function GetElement(ByVal Original As PicElement, ByVal Position As Positions) As PicElement
        Dim LineIndex As Integer = Original.LineIndex
        Dim ColumnIndex As Integer = Original.ColumnIndex

        If (Position And Positions.Bottom) <> 0 Then
            LineIndex = NextLineIndex(LineIndex)
        ElseIf (Position And Positions.Top) <> 0 Then
            LineIndex = PrevLineIndex(LineIndex)
        End If

        If (Position And Positions.Left) <> 0 Then
            ColumnIndex = PrevColIndex(ColumnIndex)
        ElseIf (Position And Positions.Right) <> 0 Then
            ColumnIndex = NextColIndex(ColumnIndex)
        End If


        Return m_Elements(ColumnIndex, LineIndex)
    End Function
    Private Function NextLineIndex(ByVal Idx As Integer) As Integer
        If Idx = m_Lines - 1 Then
            Return 0
        Else
            Return Idx + 1
        End If
    End Function
    Private Function PrevLineIndex(ByVal Idx As Integer) As Integer
        If Idx = 0 Then
            Return m_Lines - 1
        Else
            Return Idx - 1
        End If
    End Function
    Private Function NextColIndex(ByVal Idx As Integer) As Integer
        If Idx = m_Columns - 1 Then
            Return 0
        Else
            Return Idx + 1
        End If
    End Function
    Private Function PrevColIndex(ByVal Idx As Integer) As Integer
        If Idx = 0 Then
            Return m_Columns - 1
        Else
            Return Idx - 1
        End If
    End Function
End Class
