Imports System.Xml
Public Class PicElementGroup
    Inherits List(Of PicElement)
    Private m_Color As Color
    Property Color() As Color
        Get
            Return m_Color
        End Get
        Set(ByVal value As Color)
            m_Color = value
        End Set
    End Property
    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As XmlNode, ByVal AllElements As List(Of PicElement))
        m_Color = Color.FromArgb(CByte(Nd.Attributes("ColR").Value), CByte(Nd.Attributes("ColG").Value), CByte(Nd.Attributes("ColB").Value))
        Dim NumbersString As String = Nd.Attributes("Numbers").Value
        Dim Numbers As List(Of Integer) = GetNumbers(NumbersString)
        For Each Nr As Integer In Numbers
            Me.Add(AllElements(Nr))
        Next
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter, ByVal AllElements As List(Of PicElement))
        Writer.WriteAttributeString("ColR", m_Color.R.ToString)
        Writer.WriteAttributeString("ColG", m_Color.G.ToString)
        Writer.WriteAttributeString("ColB", m_Color.B.ToString)
        Dim Indizes As New List(Of String)
        For Each El As PicElement In Me
            Indizes.Add(AllElements.IndexOf(El).ToString)
        Next
        Dim Txt() As String = Indizes.ToArray
        Dim ZText As String = Join(Txt, ",")
        Writer.WriteAttributeString("Numbers", ZText)
    End Sub

    Private Function GetNumbers(ByVal Orig As String) As List(Of Integer)
        Dim Result As New List(Of Integer)
        Dim Teile() As String = Orig.Split(",")
        For Each txt As String In Teile
            If Not txt.Trim = "" Then
                Result.Add(CInt(txt))
            End If
        Next
        Return Result
    End Function
End Class
