Imports System.Xml
Public Class PicElementGroupCollection
    Private m_RaisedElements As New List(Of PicElementGroup)
    Private m_SunkenElements As New List(Of PicElementGroup)
    ReadOnly Property RaisedElements() As List(Of PicElementGroup)
        Get
            Return m_RaisedElements
        End Get
    End Property
    ReadOnly Property SunkenElements() As List(Of PicElementGroup)
        Get
            Return m_SunkenElements
        End Get
    End Property

    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As XmlNode, ByVal AllElements As List(Of PicElement))
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Grp" Then
                Dim NewGroup As New PicElementGroup(xNd, AllElements)
                Dim Style As RaisedStyles = CType(Int(xNd.Attributes("Style").Value), RaisedStyles)
                If Style = RaisedStyles.Raised Then
                    m_RaisedElements.Add(NewGroup)
                Else
                    m_SunkenElements.Add(NewGroup)
                End If
            End If
        Next
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter, ByVal AllElements As List(Of PicElement))
        For Each Grp As PicElementGroup In m_RaisedElements
            Writer.WriteStartElement("Grp")
            Writer.WriteAttributeString("Style", (CInt(RaisedStyles.Raised)).ToString)
            Grp.Write_XML(Writer, AllElements)
            Writer.WriteEndElement()
        Next
        For Each Grp As PicElementGroup In m_SunkenElements
            Writer.WriteStartElement("Grp")
            Writer.WriteAttributeString("Style", (CInt(RaisedStyles.Sunken)).ToString)
            Grp.Write_XML(Writer, AllElements)
            Writer.WriteEndElement()
        Next
    End Sub
End Class
