'Declare a class that inherits from ToolStripControlHost.

Public Class ToolStripNumericUpDown
    Inherits ToolStripControlHost


    ' Call the base constructor passing in a NumericUpDown instance.
    Public Sub New()
        MyBase.New(New NumericUpDown())
    End Sub

    Public ReadOnly Property NumericUpDownControl() As NumericUpDown
        Get
            Return CType(Control, NumericUpDown)
        End Get
    End Property
    Public Property Value() As Decimal
        Get
            Return NumericUpDownControl.Value
        End Get
        Set(ByVal value As Decimal)
            NumericUpDownControl.Value = value
        End Set
    End Property
    Public Property Minimum() As Decimal
        Get
            Return NumericUpDownControl.Minimum
        End Get
        Set(ByVal value As Decimal)
            NumericUpDownControl.Minimum = value
        End Set
    End Property
    Public Property Maximum() As Decimal
        Get
            Return NumericUpDownControl.Maximum
        End Get
        Set(ByVal value As Decimal)
            NumericUpDownControl.Maximum = value
        End Set
    End Property
    '' Expose the NumericUpDown.FirstDayOfWeek as a property.
    'Public Property FirstDayOfWeek() As Day
    '    Get
    '        Return NumericUpDownControl.FirstDayOfWeek
    '    End Get
    '    Set(ByVal value As Day)
    '        value = NumericUpDownControl.FirstDayOfWeek
    '    End Set
    'End Property

    '' Expose the AddBoldedDate method.
    'Public Sub AddBoldedDate(ByVal dateToBold As DateTime)
    '    NumericUpDownControl.AddBoldedDate(dateToBold)

    'End Sub

    ' Subscribe and unsubscribe the control events you wish to expose.
    Protected Overrides Sub OnSubscribeControlEvents(ByVal c As Control)

        ' Call the base so the base events are connected.
        MyBase.OnSubscribeControlEvents(c)

        ' Cast the control to a NumericUpDown control.
        Dim NumericUpDownControl As NumericUpDown = CType(c, NumericUpDown)

        ' Add the event.
        AddHandler NumericUpDownControl.ValueChanged, AddressOf HandleValueChanged

    End Sub

    Protected Overrides Sub OnUnsubscribeControlEvents(ByVal c As Control)
        ' Call the base method so the basic events are unsubscribed.
        MyBase.OnUnsubscribeControlEvents(c)

        ' Cast the control to a NumericUpDown control.
        Dim NumericUpDownControl As NumericUpDown = CType(c, NumericUpDown)

        ' Remove the event.
        RemoveHandler NumericUpDownControl.ValueChanged, AddressOf HandleValueChanged

    End Sub

    ' Declare the DateChanged event.
    Public Event ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)

    ' Raise the DateChanged event.
    Private Sub HandleValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        RaiseEvent ValueChanged(Me, e)
    End Sub

End Class