Public Class frm_Dots

    Private WithEvents m_Pic As BackgroundPic
    Private m_Init As Boolean = True


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        m_Pic = New BackgroundPic
        ReadNewImage()

        Dim Renderer As New MyToolStripRenderer
        Me.ToolStrip1.Renderer = Renderer
        Me.ToolStrip2.Renderer = Renderer
        Me.ToolStrip3.Renderer = Renderer
        Me.StatusStrip1.Renderer = Renderer

    End Sub
    Private Sub ReadNewImage()
        m_Init = True
        Me.ToolStripNumericUpDownPicHeight.Value = m_Pic.PicHeight
        Me.ToolStripNumericUpDownPicWidth.Value = m_Pic.PicWidth
        Me.ToolStripNumericUpDownSpalten.Value = m_Pic.HorizontalPics
        Me.ToolStripNumericUpDownZeilen.Value = m_Pic.VerticalPics
        Me.ToolStripNumericUpDownRadius.Value = m_Pic.Radius
        Me.ToolStripNumericUpDownDistanz.Value = m_Pic.PicDistance
        Me.ToolStripButtonHGIstBasis.Checked = m_Pic.UseBaseColor
        If m_Pic.UseBaseColor Then
            Me.ToolStripButtonZufallsFarben.Enabled = False
        Else
            Me.ToolStripButtonZufallsFarben.Enabled = True
        End If
        Me.DotPainter1.BMP = m_Pic.Bitmap
        m_Init = False
    End Sub

    Private Sub m_Pic_Changed() Handles m_Pic.Changed
        Me.DotPainter1.BMP = m_Pic.Bitmap
    End Sub

    Private Sub ToolStripButtonHintergrundfarbe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonHintergrundfarbe.Click
        Dim Dlg As New ColorDialog
        Dlg.Color = m_Pic.Color
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            m_Pic.Color = Dlg.Color
        End If
    End Sub

    Private Sub ToolStripButtonHGIstBasis_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonHGIstBasis.Click
        If m_Init Then Exit Sub
        ToolStripButtonHGIstBasis.Checked = Not ToolStripButtonHGIstBasis.Checked
        m_Pic.UseBaseColor = ToolStripButtonHGIstBasis.Checked
        If m_Pic.UseBaseColor Then
            Me.ToolStripButtonZufallsFarben.Enabled = False
        Else
            Me.ToolStripButtonZufallsFarben.Enabled = True
        End If
    End Sub


    Private Sub ToolStripNumericUpDownPicWidth_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownPicWidth.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.PicWidth = ToolStripNumericUpDownPicWidth.Value
    End Sub

    Private Sub ToolStripNumericUpDownPicHeight_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownPicHeight.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.PicHeight = ToolStripNumericUpDownPicHeight.Value
    End Sub

  
    Private Sub ToolStripNumericUpDownSpalten_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownSpalten.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.HorizontalPics = ToolStripNumericUpDownSpalten.Value
    End Sub

    Private Sub ToolStripNumericUpDownZeilen_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownZeilen.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.VerticalPics = ToolStripNumericUpDownZeilen.Value
    End Sub

    Private Sub ToolStripNumericUpDownRadius_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownRadius.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.Radius = ToolStripNumericUpDownRadius.Value
    End Sub

    Private Sub ToolStripNumericUpDownDistanz_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripNumericUpDownDistanz.ValueChanged
        If m_Init Then Exit Sub
        m_Pic.PicDistance = ToolStripNumericUpDownDistanz.Value
    End Sub

    Private Sub ToolStripButtonDotsNeuVerteilen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonDotsNeuVerteilen.Click
        m_Pic.Neu_Erstellen()
    End Sub

    Private Sub ToolStripButtonZufallsFarben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonZufallsFarben.Click
        m_Pic.Farben_Neu_Verteilen()
    End Sub

    Private Sub ToolStripButtonBitmapSpeichern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonBitmapSpeichern.Click
        Dim Dlg As New SaveFileDialog
        Dlg.Title = "Bitmap speichern"
        Dlg.Filter = "PNG Image|*.png|Jpeg Image|*.jpg|Bitmap Image|*.bmp|Gif Image|*.gif"
        Dlg.AddExtension = True
        Dlg.OverwritePrompt = True
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            If Dlg.FileName.ToLower.EndsWith(".png") Then
                m_Pic.Bitmap.Save(Dlg.FileName, Drawing.Imaging.ImageFormat.Png)
            ElseIf Dlg.FileName.ToLower.EndsWith(".jpg") Then
                m_Pic.Bitmap.Save(Dlg.FileName, Drawing.Imaging.ImageFormat.Jpeg)
            ElseIf Dlg.FileName.ToLower.EndsWith(".gif") Then
                m_Pic.Bitmap.Save(Dlg.FileName, Drawing.Imaging.ImageFormat.Gif)
            ElseIf Dlg.FileName.ToLower.EndsWith(".bmp") Then
                m_Pic.Bitmap.Save(Dlg.FileName, Drawing.Imaging.ImageFormat.Bmp)
            End If
        End If
    End Sub


    Private Sub ToolStripButtonNeueDatei_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonNeueDatei.Click
        m_Pic.Neu_Erstellen()
    End Sub

    Private Sub ToolStripButtonDateiOeffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonDateiOeffnen.Click
        Dim Dlg As New OpenFileDialog
        Dlg.Filter = "Dot Image Dateien|*.xmldotimg"
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            m_Pic = New BackgroundPic(Dlg.FileName)
            ReadNewImage()
        End If
    End Sub

    Private Sub ToolStripButtonDateiSpeichern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonDateiSpeichern.Click
        Dim Dlg As New SaveFileDialog
        Dlg.Filter = "Dot Image Dateien|*.xmldotimg"
        If m_Pic.FileName <> "" Then
            Dlg.FileName = m_Pic.FileName
        End If
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            m_Pic.FileName = Dlg.FileName
            m_Pic.Speichern()
        End If
    End Sub
End Class
